pw_properties Class Reference

A collection of key/value pairs. More...

## Public Member Functions

SPA_EXPORT struct pw_properties * | pw_properties_new (const char *key,...)
| Make a new properties object. More...
SPA_EXPORT struct pw_properties * | pw_properties_new_dict (const struct spa_dict *dict)
| Make a new properties object from the given dictionary. More...
SPA_EXPORT struct pw_properties * | pw_properties_new_string (const char *str)
| Make a new properties object from the given str. More...
SPA_EXPORT struct pw_properties * | pw_properties_copy (const struct pw_properties *properties)
| Copy a properties object. More...
SPA_EXPORT struct pw_properties * | pw_properties_merge (const struct pw_properties *oldprops, struct pw_properties *newprops)
| Merge properties into one. More...
SPA_EXPORT void | pw_properties_free (struct pw_properties *properties)
| Free a properties object. More...
SPA_EXPORT int | pw_properties_set (struct pw_properties *properties, const char *key, const char *value)
| Set a property value. More...
SPA_EXPORT int | pw_properties_setf (struct pw_properties *properties, const char *key, const char *format,...)
| Set a property value by format. More...
SPA_EXPORT const char * | pw_properties_get (const struct pw_properties *properties, const char *key)
| Get a property. More...
SPA_EXPORT const char * | pw_properties_iterate (const struct pw_properties *properties, void **state)
| Iterate property values. More...

## Data Fields

struct spa_dict | dict

## Detailed Description

A collection of key/value pairs.

Properties are used to pass around arbitrary key/value pairs. Both keys and values are strings which keeps things simple. Encoding of arbitrary values should be done by using a string serialization such as base64 for binary blobs.

## Member Function Documentation

## pw_properties_copy()

SPA_EXPORT struct pw_properties * pw_properties_copy | ( | const struct pw_properties * | properties | ) |

Copy a properties object.

Parameters

  properties | properties to copy

Returns
  a new properties object

References pw_array_for_each, and pw_properties_new().

## pw_properties_free()

SPA_EXPORT void pw_properties_free | ( | struct pw_properties * | properties | ) |

Free a properties object.

Parameters

  properties | the properties to free

References pw_array_for_each.

## pw_properties_get()

SPA_EXPORT const char * pw_properties_get | ( | const struct pw_properties * | properties,
|  | const char * | key
| ) |  |

Get a property.

Parameters

  properties | a pw_properties
  key | a key

Returns
  the property for key or NULL when the key was not found

Get the property in properties with key.

## pw_properties_iterate()

SPA_EXPORT const char * pw_properties_iterate | ( | const struct pw_properties * | properties,
|  | void ** | state
| ) |  |

Iterate property values.

Parameters

  properties | a pw_properties
  state | state

Returns
  The next key or NULL when there are no more keys to iterate.

Iterate over properties, returning each key in turn. state should point to a pointer holding NULL to get the first element and will be updated after each iteration. When NULL is returned, all elements have been iterated.

## pw_properties_merge()

SPA_EXPORT struct pw_properties * pw_properties_merge | ( | const struct pw_properties * | oldprops,
|  | struct pw_properties * | newprops
| ) |  |

Merge properties into one.

Parameters

  oldprops | properties to merge into
  newprops | properties to merge

Returns
  a newly allocated pw_properties

A new pw_properties is allocated and the properties of oldprops and newprops are copied into it in that order.

References pw_properties_copy(), pw_properties_get(), pw_properties_iterate(), and pw_properties_set().

## pw_properties_new()

SPA_EXPORT struct pw_properties * pw_properties_new | ( | const char * | key,
|  |  | ...
| ) |  |

Make a new properties object.

Parameters

  key | a first key
  ... | value and more keys NULL terminated

Returns
  a newly allocated properties object

## pw_properties_new_dict()

SPA_EXPORT struct pw_properties * pw_properties_new_dict | ( | const struct spa_dict * | dict | ) |

Make a new properties object from the given dictionary.

Parameters

  dict | a dictionary. keys and values are copied

Returns
  a new properties object

## pw_properties_new_string()

SPA_EXPORT struct pw_properties * pw_properties_new_string | ( | const char * | str | ) |

Make a new properties object from the given str.

str should be a whitespace separated list of key=value strings.

Parameters

  args | a property description

Returns
  a new properties object

## pw_properties_set()

SPA_EXPORT int pw_properties_set | ( | struct pw_properties * | properties,
|  | const char * | key,
|  | const char * | value
| ) |  |

Set a property value.

Parameters

  properties | the properties to change
  key | a key
  value | a value or NULL to remove the key

Returns
  1 if the properties were changed. 0 if nothing was changed because the property already existed with the same value or because the key to remove did not exist.

Set the property in properties with key to value. Any previous value of key will be overwritten. When value is NULL, the key will be removed.

## pw_properties_setf()

SPA_EXPORT int pw_properties_setf | ( | struct pw_properties * | properties,
|  | const char * | key,
|  | const char * | format,
|  |  | ...
| ) |  |

Set a property value by format.

Parameters

  properties | a pw_properties
  key | a key
  format | a value
  ... | extra arguments

Returns
  1 if the properties were changed. 0 if nothing was changed because the property already existed with the same value.

Set the property in properties with key to the value in printf style format Any previous value of key will be overwritten.

References pw_properties_setva().

## Field Documentation

## dict

struct spa_dict pw_properties::dict

Referenced by pw_core::pw_core_new(), pw_factory_new(), and pw_port_new().

The documentation for this class was generated from the following files:

- properties.h
- properties.c